#include <stdio.h>
#include <tiuser.h>
#include <fcntl.h>
#include <sys/types.h>
#include <netdb.h>
#include <stropts.h>
#include "tpinfo.h"

int rpopen();

main(argc, argv)
int argc;
char **argv;
{
        int fd;
        char buff[BUFSIZ];
        int nbytes;

        /*
         *  Check for proper usage
         */

        if (argc < 4) {
                 fprintf(stderr,"Usage: %s host command type\n",
                                                          argv[0]);
                 exit(1);
        }

        fd = rpopen(argv[1], argv[2], argv[3]);
        if (fd < 0) {
                exit(1);
        }
        if (argv[3][0] == 'r') {
           while ((nbytes = rpread(fd, buff, 5)) != 0) {
                write(1, buff, nbytes);
           }
        } else {
           while ((nbytes = read(0, buff, 10)) != 0) {
                if (rpwrite(fd, buff, nbytes) < 0) {
  			printf("rpwrite failed!\n");
			exit(1);
                }
           }
        }
        rpclose(fd);
}
