#include <stdio.h>
#include <netdb.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/uio.h>

#define SERV_ADDR  "/tmp/example1"

main()
{
   struct msghdr msg;
   struct sockaddr_un servaddr;
   struct sockaddr_un client_addr;
   int length;
   int sfd;
   int recfd;
   int retval;
   static int fd_array[2];
   char c[BUFSIZ];
   char a[BUFSIZ];
   char b[BUFSIZ];
   char d[BUFSIZ];

   /*
    *  Get a socket into the AF_UNIX domain
    */

   if ((sfd = socket(AF_UNIX, SOCK_STREAM, 0)) < 0) {
      return(-1);
   }

   /*
    *  Fill in our address and bind to it
    */

   bzero((char *)&servaddr, sizeof(servaddr));
   servaddr.sun_family = AF_UNIX;
   strcpy(servaddr.sun_path, SERV_ADDR);

   if (bind(sfd, (struct sockaddr *)&servaddr,
           strlen(SERV_ADDR) + sizeof(servaddr.sun_family)) < 0) {
      close(sfd);
      return(-1);
   }

   /*
    *  Set the socket up for listening, with a queue
    *  length of 1
    */

   if (listen(sfd, 1) < 0) {
      close(sfd);
      return(-1);
   }

   length = sizeof(client_addr);
   if ((recfd = accept(sfd,
        (struct sockaddr_in *)&client_addr, &length)) < 0) {
         perror("could not accept call");
         exit(1);
   }

   recv_names(recfd, c, a, b, d, 100);
   printf("..[%s] [%s] [%s] [%s]...\n", c, a, b, d);

   close(sfd);
   return(retval);
}
